///////////////////////////////////////////////////////////////
// xNX CBSchLabel ̓̒`s܂

#include "stdafx.h"
#include "NL.h"
#include "BSchObj.h"
#include "BSchLbl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//f[^Lǂ𒲂ׂ
BOOL CBSchLabel::IsValid()
{
	if(!m_psz) return FALSE;
	if(lstrlen(m_psz)==0) return FALSE;
	return TRUE;
}	

//IuWFNg̕
CBSchObj* CBSchLabel::Duplicate()
{
	CBSchLabel* pObj=new CBSchLabel;
	if(!pObj) return NULL;
	pObj->m_dwType		=this->m_dwType;
	pObj->m_dwStus		=this->m_dwStus;
	pObj->m_nMoveFrom	=this->m_nMoveFrom;
	pObj->m_p0			=this->m_p0;
	pObj->m_nLayer		=this->m_nLayer;
	if(this->m_psz){
		pObj->m_psz=new char[lstrlen(this->m_psz)+1];
		lstrcpy(pObj->m_psz,this->m_psz);
	}
	return (CBSchObj*)pObj;
}

////////////////////////////////////////////////////////////////////////////////
//CE2t@Co
#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//t@Cւ̏
//TRUEBsFALSEԂ
BOOL CBSchLabel::WriteCE2(CFile* pFile,CPoint* pOrigin /* =NULL*/)
{
	int i,nStrLen,nx,ny;
	BOOL bResult=TRUE;
	char *ps, *pd;
	
	struct{			//ݗp̍\
		BYTE	bId;			//ID
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		char    passtrName[12];	//^O
	}ce2label;

	if(!m_psz) return TRUE;
	nStrLen=lstrlen(m_psz);
	if(!nStrLen) return TRUE;


	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}

	ce2label.bId  	=CE2_LABEL;
	if(m_dwType==LABEL_VERT) ce2label.bStus=0x8; else ce2label.bStus=0;
	ce2label.bStus |= (m_nLayer & 0x0F)<<4;	//1998/06/27
	ce2label.x		=m_p0.x-nx;
	ce2label.y		=m_p0.y-ny;
	if(nStrLen>10)nStrLen=10;			//
	ce2label.passtrName[0]=nStrLen;		//obt@̐擪ɕ			
	ps=m_psz;							//̃Rs[
	pd=&(ce2label.passtrName[1]);
	for(i=0;i<nStrLen;i++) *pd++=*ps++;
	try{
		pFile->Write(&ce2label,sizeof(ce2label));
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	return bResult;
}



//t@C̓ǂݍ
BOOL CBSchLabel::ReadCE2(CFile* pFile,BYTE bCE2Id,CPoint* pOrigin/* =NULL*/)
{
	int nx,ny,n;
	struct{			//ǂݍݗp̍\
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		char    passtrName[12];	//^O
	}ce2label;

	if(bCE2Id!=CE2_LABEL) return FALSE;
	UINT uResult=pFile->Read(&ce2label,sizeof(ce2label));
	if(uResult<sizeof(ce2label)) return FALSE;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
    m_dwStus=0;	
	if(ce2label.bStus&8) m_dwType=LABEL_VERT; else m_dwType=LABEL_HORZ;
	m_p0.x=(int)ce2label.x+nx;
	m_p0.y=(int)ce2label.y+ny;

	n=ce2label.passtrName[0];		//𓾂
	if(n>10)n=10;					//ő啶
	m_psz=new char[n+1];		//̃m
	lstrcpyn(m_psz,&(ce2label.passtrName[1]),n+1);//񕡎
	*(m_psz+n)=0;
	//C[̐ݒ
	m_nLayer=(ce2label.bStus & 0xF0)>>4;

	return TRUE;
}

#pragma pack()		//\̂̋EftHglɖ߂






