///////////////////////////////////////////////////////////////
// ^ONX CBSchTag ̓̒`s܂

#include "stdafx.h"
//#include "BSch.h"

//#include "BSchFont.h"
//#include "Global.h"
#include "BSchObj.h"
#include "BSchTag.h"
//#include "TagAtrb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//^O̕Ԃ n͕
int CBSchTag::GetWidth(int n)
{
	static int narrayTagWidth[]={20,20,30,40,50,60,70,80,80,90,100,110,120};
	if(n<0) return n=0;
	if(n<=12) return narrayTagWidth[n];	//CEƂ̌݊
	else return ((n*8+9)/10)*10+20;		//ȏ͏̊gp
}

//nԖڂ̃s̈ʒu𓾂
BOOL CBSchTag::GetPinPosition(int nPin,CPoint* pptPin)
{
	if(nPin<0 || nPin>1)return FALSE;
	int nStrLen;
	int nWidth;
	if(nPin==0){
		pptPin->x=m_p0.x;
		pptPin->y=m_p0.y;
	}else{
		if(m_pszName) nStrLen=lstrlen(m_pszName);
		else          nStrLen=0;
		//𓾂
		nWidth=GetWidth(nStrLen);
		pptPin->x=m_p0.x+nWidth;
		pptPin->y=m_p0.y;
	}
	return TRUE;
}

//̈ʒu擾
CPoint CBSchTag::GetPointLT()
{
	return m_p0;
}





//IuWFNg̕
CBSchObj* CBSchTag::Duplicate()
{
	CBSchTag* pObj=new CBSchTag;
	if(!pObj) return NULL;
	pObj->m_dwType		=this->m_dwType;
	pObj->m_dwStus		=this->m_dwStus;
	pObj->m_nMoveFrom	=this->m_nMoveFrom;
	pObj->m_p0			=this->m_p0;
	pObj->m_nLayer		=this->m_nLayer;
	if(this->m_pszName){
		pObj->m_pszName=new char[lstrlen(this->m_pszName)+1];
		lstrcpy(pObj->m_pszName,this->m_pszName);
	}
	return (CBSchObj*)pObj;
}

//^Oɕݒ
void CBSchTag::SetTagString(LPCSTR psz)
{
	delete[]m_pszName;
	m_pszName=NULL;
	if(psz){
		int n=lstrlen(psz);
		m_pszName=new char[n+1];
		lstrcpy(m_pszName,psz);
	}
}


////////////////////////////////////////////////////////////////////////////////
//CE2t@Co
#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//t@Cւ̏
//TRUEBsFALSEԂ
BOOL CBSchTag::WriteCE2(CFile* pFile,CPoint* pOrigin /* =NULL*/)
{
	int i,nStrLen,nx,ny;
	BOOL bResult=TRUE;
	char *ps, *pd;
	
	struct{			//ݗp̍\
		BYTE	bId;			//ID
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		char    passtrName[12];	//^O
	}ce2tag;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}

	ce2tag.bId  	=CE2_TAG;
	ce2tag.bStus	=(BYTE)(m_dwType&3) | (m_nLayer & 0x0F)<<4;
	ce2tag.x		=m_p0.x-nx;
	ce2tag.y		=m_p0.y-ny;
	if(m_pszName) nStrLen=lstrlen(m_pszName);
	else          nStrLen=0;
	if(nStrLen>10)nStrLen=10;						//
	ce2tag.passtrName[0]=nStrLen;		//obt@̐擪ɕ			
	ps=m_pszName;						//̃Rs[
	pd=&(ce2tag.passtrName[1]);
	for(i=0;i<nStrLen;i++) *pd++=*ps++;

	try{
		pFile->Write(&ce2tag,sizeof(ce2tag));
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	return bResult;
}



//t@C̓ǂݍ
BOOL CBSchTag::ReadCE2(CFile* pFile,BYTE bCE2Id,CPoint* pOrigin/* =NULL*/)
{
	int nx,ny,n;
	struct{			//ǂݍݗp̍\
		BYTE	bStus;			//Xe[^X
		short	x;				//wW
		short	y;				//xW
		char    passtrName[12];	//^O
	}ce2tag;

	if(bCE2Id!=CE2_TAG) return FALSE;
	UINT uResult=pFile->Read(&ce2tag,sizeof(ce2tag));
	if(uResult<sizeof(ce2tag)) return FALSE;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
    m_dwType=ce2tag.bStus&3;
    m_dwStus=0;	
	m_p0.x=(int)ce2tag.x+nx;
	m_p0.y=(int)ce2tag.y+ny;

	n=ce2tag.passtrName[0];		//𓾂
	if(n>10)n=10;					//ő啶
	m_pszName=new char[n+1];		//̃m
	lstrcpyn(m_pszName,&(ce2tag.passtrName[1]),n+1);//񕡎
	*(m_pszName+n)=0;
	//C[̐ݒ
	m_nLayer=(ce2tag.bStus & 0xF0)>>4;

	return TRUE;
}

#pragma pack()		//\̂̋EftHglɖ߂






